#!/usr/bin/python
 
from poaupdater import uSysDB, uLogging, uDialog
 
print """
################################################################################################
# Usage:
# export LANG=en_US.UTF-8
# export PGCLIENTENCODING=UTF8
# python find_invalid_symbols.py | tee >(grep "find_invalid_symbols" > find_invalid_symbols.log)
################################################################################################
"""
invalid="\303\220"

def main():
	con = uSysDB.connect()
	cur = con.cursor()
	cur.execute("""
	SELECT c.table_schema schemaname, c.table_name tablename, c.column_name columnname
	FROM information_schema.columns c JOIN information_schema.tables t
	ON (t.table_name=c.table_name AND t.table_schema=c.table_schema)
	WHERE c.table_schema=ANY('{public}') AND t.table_type='BASE TABLE' AND c.data_type like '%char%'
	AND t.table_name <> 'login_history'
	order by schemaname, tablename, columnname
	""")

	sql2="""
	SELECT cast(ctid as text), cast(%s as text), convert_from(convert(%s::bytea, 'UTF8', 'LATIN1'), 'UTF8') FROM \"%s\".\"%s\"
	WHERE cast(%s as text) like '%%' || substring(convert_from(BYTEA '%s', 'UTF8') from 1 for 1) || '%%'
	"""
	count = 0
	for schemaname, tablename, columnname in cur.fetchall():
	    cur2 = con.cursor()
	    cur2.execute(sql2 % (columnname, columnname, schemaname, tablename, columnname, invalid))
	    for ctid, data, data_fixed in cur2.fetchall():
	        count += 1
	        log = "find_invalid_symbols[%d]: SELECT \"%s\" FROM \"%s\".\"%s\" WHERE ctid='%s'::tid; -- OLD: '%s' NEW: '%s', UPDATING..."
	        update_sql = """
	        UPDATE %s
	        SET %s = '%s'
	        WHERE ctid = '%s'::tid AND %s = '%s'
	        """
	        try:
	            uLogging.notice(log % (count, columnname, schemaname, tablename, ctid, data, data_fixed))
	            cur3 = con.cursor()
	            cur3.execute(update_sql % (tablename, columnname, data_fixed, ctid, columnname, data))
		except KeyboardInterrupt:
	            uLogging.warn("Do you want to apply the changes?")
	            if uDialog.askYesNo():
	                con.commit()
	                return

	        except Exception,e:
	            uLogging.err(e)
	            con.rollback()
	            con.close() #aborting.
	            return

	con.commit()

main()
