#!/usr/bin/python

from poaupdater import uSysDB

print """
################################################################################################
# Use:
# export LANG=en_US.UTF-8
# export PGCLIENTENCODING=UTF8
# python find_invalid_symbols.py | tee >(grep "find_invalid_symbols" > find_invalid_symbols.log)
################################################################################################
# See also (UTF8 en_US.UTF-8):
#-----------------------------------------------------------------------------------------------
# plesk=> SHOW SERVER_ENCODING;
# plesk=> SHOW CLIENT_ENCODING;
# echo $PGCLIENTENCODING
# echo $LANG
################################################################################################
"""

invalid="\303\220"

con = uSysDB.connect()
cur = con.cursor()
cur.execute("""
SELECT c.table_schema schemaname, c.table_name tablename, c.column_name columnname
FROM information_schema.columns c JOIN information_schema.tables t
ON (t.table_name=c.table_name AND t.table_schema=c.table_schema)
WHERE c.table_schema=ANY('{public}') AND t.table_type='BASE TABLE' AND c.data_type like '%char%'
order by schemaname, tablename, columnname
""")

sql2="""
SELECT cast(ctid as text), cast(%s as text) FROM \"%s\".\"%s\"
WHERE cast(%s as text) like '%%' || convert_from(BYTEA '%s', 'utf-8') || '%%'
"""
count = 0
for schemaname, tablename, columnname in cur.fetchall():
        cur2 = con.cursor()
        cur2.execute(sql2 % (columnname, schemaname, tablename, columnname, invalid))
        for ctid, data in cur2.fetchall():
                count += 1
                log = "find_invalid_symbols[%d]: SELECT \"%s\" FROM \"%s\".\"%s\" WHERE ctid='%s'::tid; -- '%s'"
                print log % (count, columnname, schemaname, tablename, ctid, data)

